Skip to main content

FilterQuery overview

FilterQuery is a text input component that lets users type structured filter queries, such as Status: Open and Age: >30. It converts these queries into a parsed filter configuration that your app can use.

For data-heavy apps where users need to filter large datasets quickly, FilterQuery provides a keyboard-driven alternative to clicking through dropdowns. It offers syntax highlighting, autocomplete, and outputs structured rules that your filtering logic can use directly.

Basic usage

<script setup>
import { ref } from "vue";
import { FilterQuery, createArrayFilter } from "@svar-ui/vue-filter";

const fields = [
{ id: "status", label: "Status", type: "text" },
{ id: "age", label: "Age", type: "number" },
];

const options = {
status: ["Open", "Closed", "In Progress"],
};

let data = [/* your records */];
const filteredData = ref(data);

function handleFilter({ value, error }) {
if (error && error.code !== "NO_DATA") return;
const filter = createArrayFilter(value, {}, fields);
filteredData.value = filter(data);
}
</script>

<template>
<FilterQuery
:fields="fields"
:options="options"
:onchange="handleFilter"
/>
</template>

This renders a single-line input with a search button. As the user types, a syntax highlighting overlay colorizes field names, values, and operators in real time. An autocomplete dropdown shows matching fields or values from options. When the user presses Enter or clicks Search, onchange fires with the parsed filter config.

Pass that config to createArrayFilter to filter a local array, or send it to your backend.

How it works

  1. The user starts typing a query like Status: - the autocomplete dropdown lists available fields.
  2. After the colon, suggestions switch to values from options.
  3. Syntax highlighting shows query structure in real time and underlines unknown fields or bad syntax in red.
  4. Pressing Enter (or clicking the search button) fires onchange.
  5. The event payload carries value (a parsed filtering rule), text (the normalized query string), and an error field when validation fails.

When to use FilterQuery

FilterQuery is suited for dashboards, admin panels, task managers, and CRMs where users need fast, keyboard-driven filtering. It performs best when users understand the data schema and want to type queries directly. Typical users include developers, analysts, and operations teams who require precise control over record filtering.

Next steps

Skip to main content

FilterQuery overview

FilterQuery is a text input component that lets users type structured filter queries, such as Status: Open and Age: >30. It converts these queries into a parsed filter configuration that your app can use.

For data-heavy apps where users need to filter large datasets quickly, FilterQuery provides a keyboard-driven alternative to clicking through dropdowns. It offers syntax highlighting, autocomplete, and outputs structured rules that your filtering logic can use directly.

Basic usage

import { useState } from "react";
import { FilterQuery, createArrayFilter } from "@svar-ui/react-filter";

function App() {
const fields = [
{ id: "status", label: "Status", type: "text" },
{ id: "age", label: "Age", type: "number" },
];

const options = {
status: ["Open", "Closed", "In Progress"],
};

const data = [/* your records */];
const [filteredData, setFilteredData] = useState(data);

function handleFilter({ value, error }) {
if (error && error.code !== "NO_DATA") return;
const filter = createArrayFilter(value, {}, fields);
setFilteredData(filter(data));
}

return (
<FilterQuery
fields={fields}
options={options}
onChange={handleFilter}
/>
);
}

export default App;

This renders a single-line input with a search button. As the user types, a syntax highlighting overlay colorizes field names, values, and operators in real time. An autocomplete dropdown shows matching fields or values from options. When the user presses Enter or clicks Search, onChange fires with the parsed filter config.

Pass that config to createArrayFilter to filter a local array, or send it to your backend.

How it works

  1. The user starts typing a query like Status: - the autocomplete dropdown lists available fields.
  2. After the colon, suggestions switch to values from options.
  3. Syntax highlighting shows query structure in real time and underlines unknown fields or bad syntax in red.
  4. Pressing Enter (or clicking the search button) fires onChange.
  5. The event payload carries value (a parsed filtering rule), text (the normalized query string), and an error field when validation fails.

When to use FilterQuery

FilterQuery is suited for dashboards, admin panels, task managers, and CRMs where users need fast, keyboard-driven filtering. It performs best when users understand the data schema and want to type queries directly. Typical users include developers, analysts, and operations teams who require precise control over record filtering.

Next steps